// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Net;
using System.IO;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;
using System.Threading;
using MonoCalendar.i18n;

namespace MonoCalendar {
	public class UpdateMonoCalendar : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonClose;
		private System.Windows.Forms.LinkLabel linkLabel1;
		public String checkedVersion = "";
		public String currentVersion = "";
		string windowsCulture;
		
		public UpdateMonoCalendar(string wc)
		{
			windowsCulture = wc;
			InitializeComponent();
			label1.Left = 10;
			label1.Top = 10;
			linkLabel1.Left = label1.Right + 10;
			linkLabel1.Top = 10;
			buttonClose.Top = label1.Bottom + 25;
			buttonClose.Left = (linkLabel1.Right - buttonClose.Width)/2;
			this.SetClientSizeCore(linkLabel1.Right + 10,buttonClose.Bottom + 10);
		}
		
		public void Translate()
		{
			this.buttonClose.Text = tr.GetString("Close");
			this.Text = String.Format("MonoCalendar {0}", currentVersion);
			this.label1.Text = String.Format(tr.GetString("Available version {0}. Download it from:"), checkedVersion);
		}

		#region Cdigo generado por el Diseador de Windows Forms
		
		void InitializeComponent() {
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.buttonClose = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// linkLabel1
			// 
			this.linkLabel1.AutoSize = true;
			this.linkLabel1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.linkLabel1.Location = new System.Drawing.Point(144, 48);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(157, 16);
			this.linkLabel1.TabIndex = 2;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "http://www.monocalendar.com";
			this.linkLabel1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.LinkLabel1LinkClicked);
			// 
			// buttonClose
			// 
			this.buttonClose.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonClose.Location = new System.Drawing.Point(144, 80);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.Size = new System.Drawing.Size(88, 24);
			this.buttonClose.TabIndex = 0;
			this.buttonClose.Text = "button1";
			this.buttonClose.Click += new System.EventHandler(this.ButtonCloseClick);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label1.Location = new System.Drawing.Point(104, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(201, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Available version {0}. Download it from:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// UpdateMonoCalendar
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 113);
			this.Controls.Add(this.linkLabel1);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonClose);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "UpdateMonoCalendar";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.TopMost = true;
			this.ResumeLayout(false);
		}

		#endregion

		bool TestNewVersion() {
			WebClient client = new WebClient ();
			try {
				Version v = Assembly.GetEntryAssembly().GetName().Version;
				currentVersion = String.Format("{0}.{1}.{2}", v.Major, v.Minor, v.Build);
				String URL = String.Format("http://www.monocalendar.com/version.php?version={0}&lang={1}", currentVersion, windowsCulture);
				Stream data = client.OpenRead (URL);
				StreamReader reader = new StreamReader(data);
				checkedVersion = reader.ReadToEnd();
				data.Close();
				reader.Close();
				if (checkedVersion != currentVersion) {
					return true;
				}
			} catch {
				Console.WriteLine("Url not found");
			}
			return false;
		}

		public delegate void CheckVersionDelegate(bool show);

		public void CheckVersion(bool show) {
			if (TestNewVersion()) {
				if (NewVersion != null) NewVersion(this, null);
			} else {
				if (show) {
					string message = String.Format(tr.GetString("This version of MonoCalendar ({0}) is the current"), currentVersion);
					string caption = "MonoCalendar";
					MessageBoxButtons buttons = MessageBoxButtons.OK;
					MessageBox.Show(this, message, caption, buttons, MessageBoxIcon.Information);
				}
			}
		}

		public event EventHandler NewVersion;

		void ButtonCloseClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
		void LinkLabel1LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.monocalendar.com/downloads.html");
		}
		
	}
}
